using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace P5_4
{
    /// <summary>
    /// Это главный тип игры
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        spriteComp gameObject, gameObject1;
        //Для хранения ID касаний
        int gameObjectId, gameObjectId1;
        Texture2D texture;
        //Шаг перемещения спрайта, то есть - скорость
        float sprSpeed = 4;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            graphics.IsFullScreen = true;
            // Частота кадра на Windows Phone по умолчанию — 30 кадров в секунду.
            TargetElapsedTime = TimeSpan.FromTicks(333333);

            // Дополнительный заряд аккумулятора заблокирован.
            InactiveSleepTime = TimeSpan.FromSeconds(1);
        }

        /// <summary>
        /// Позволяет игре выполнить инициализацию, необходимую перед запуском.
        /// Здесь можно запросить нужные службы и загрузить неграфический
        /// контент.  Вызов base.Initialize приведет к перебору всех компонентов и
        /// их инициализации.
        /// </summary>
        protected override void Initialize()
        {
            // ЗАДАЧА: добавьте здесь логику инициализации

            base.Initialize();
        }

        /// <summary>
        /// LoadContent будет вызываться в игре один раз; здесь загружается
        /// весь контент.
        /// </summary>
        protected override void LoadContent()
        {
            // Создайте новый SpriteBatch, который можно использовать для отрисовки текстур.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            Services.AddService(typeof(SpriteBatch), spriteBatch);
            texture = Content.Load<Texture2D>("BallandBats");
            CreateNewObject();
           
            // ЗАДАЧА: используйте здесь this.Content для загрузки контента игры
        }

        protected void CreateNewObject()
        {
            gameObject = new spriteComp(this, ref texture,
                new Rectangle(18, 9, 17, 88),
                new Vector2(50, 150));
            Components.Add(gameObject);
            gameObject1 = new spriteComp(this, ref texture,
                new Rectangle(17, 106, 17, 88),
                new Vector2(750, 150));
            Components.Add(gameObject1);

        }


        /// <summary>
        /// UnloadContent будет вызываться в игре один раз; здесь выгружается
        /// весь контент.
        /// </summary>
        protected override void UnloadContent()
        {
            // ЗАДАЧА: выгрузите здесь весь контент, не относящийся к ContentManager
        }

        /// <summary>
        /// Позволяет игре запускать логику обновления мира,
        /// проверки столкновений, получения ввода и воспроизведения звуков.
        /// </summary>
        /// <param name="gameTime">Предоставляет моментальный снимок значений времени.</param>
        protected override void Update(GameTime gameTime)
        {
            // Позволяет выйти из игры
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            //Получаем коллекцию объектов, содержащих информацию о касаниях экрана
            TouchCollection touchLocations = TouchPanel.GetState();
            //Перебираем коллекцию, присваивая объекту координаты касания
            foreach (TouchLocation touchLocation in touchLocations)
            {
               //Если произошло касание
                if (touchLocation.State == TouchLocationState.Pressed)
                {
                    //Управление объектом, расположенным у левого края экрана, перемещение вверх
                    if (touchLocation.Position.X > 0 && touchLocation.Position.X < 200 && 
                        touchLocation.Position.Y>0&&touchLocation.Position.Y<240)
                    {
                        gameObjectId = touchLocation.Id;
                        gameObject.Move(new Vector2(0, -sprSpeed));
                    }
                     
                    //Управление объектом, расположенным у левого края экрана, перемещение вниз
                    if (touchLocation.Position.X > 0 && touchLocation.Position.X < 200 && 
                        touchLocation.Position.Y > 240 && touchLocation.Position.Y < 480)
                    {
                        gameObjectId = touchLocation.Id;
                        gameObject.Move(new Vector2(0, sprSpeed));
                    }
                    //Управление объектом, расположенным у правого края экрана, перемещение вверх
                    if (touchLocation.Position.X > 600 && touchLocation.Position.X < 800 && 
                        touchLocation.Position.Y > 0 && touchLocation.Position.Y < 240)
                    {
                        gameObjectId1 = touchLocation.Id;
                        gameObject1.Move(new Vector2(0, -sprSpeed));
                    }

                    //Управление объектом, расположенным у правого края экрана, перемещение вниз
                    if (touchLocation.Position.X > 600 && touchLocation.Position.X < 800 && 
                        touchLocation.Position.Y > 240 && touchLocation.Position.Y < 480)
                    {
                        gameObjectId1 = touchLocation.Id;
                        gameObject1.Move(new Vector2(0, sprSpeed));
                    }            
              
                    }

                //Если касание окончилось
                if (touchLocation.State == TouchLocationState.Released)
                {
                    if (touchLocation.Id == gameObjectId)
                    {
                        gameObject.Move(new Vector2(0, 0));
                    }
                    if (touchLocation.Id == gameObjectId1)
                    {
                        gameObject1.Move(new Vector2(0, 0));
                    }
                }

            }

            base.Update(gameTime);
        }

        /// <summary>
        /// Вызывается, когда игра отрисовывается.
        /// </summary>
        /// <param name="gameTime">Предоставляет моментальный снимок значений времени.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            spriteBatch.Begin();
            base.Draw(gameTime);
            spriteBatch.End();

        }
    }
}
